include('controller.lua');

local defaultProfile	=	'default';
local defaultType		=	'PS2';

function macro.init(scriptpath, profile, _type)
	local profile = profile or 'default';
	local _type = _type or 'PS2';	

	controller = Controller(profile, _type);

	printf("Enjoy your game! Everything should be working.\n\n");
end

function macro.main(dt)
	
	return true;
end

function macro.event(e, ...)
	if( e == "gamepadpressed" ) then
		local gamepadId, btnId = ...;
		controller:translate(btnId, 'press');
	elseif( e == "gamepadreleased" ) then
		local gamepadId, btnId = ...;
		controller:translate(btnId, 'release');
	elseif( e == "gamepadpovchanged" ) then
		local gamepadId, angle = ...;
		if( angle == JOY_POVCENTERED ) then
			controller:translate('POV', 'center');
		else
			controller:translate('POV', 'change', angle);
		end
	elseif( e == "gamepadaxischanged" ) then
		--[[	Note: Rather than rely on the event to extract the axis data,
				We'll just manually grab it so we can get all sets of data at once.
				Additionally, we need to do some simple trigonometry to calculate the angle
		]]
		local gamepadId, axisId = ...;

		-- We want to ignore anything but axis 1 & 2 (for now)
		if( axisId ~= 1 and axisId ~= 2 ) then
			return;
		end

		local axis1 = gamepad.getAxis(gamepadId, 1);
		local axis2 = gamepad.getAxis(gamepadId, 2);
		local dist = math.distance(50, 50, axis1, axis2);

		if( dist < 10 ) then
			controller:translate('POV', 'center');
		else
			local angle = 360 - math.deg(math.atan2(axis1 - 50, axis2 - 50) + math.pi);
			controller:translate('POV', 'change', angle);
		end
	end
end